/******************************************************************
 * This is xvtmon v0.1 (7-08-1995)
 * Copyright (C) 1995 Alexandre Naaman <hoser@step.polymtl.ca>
 ******************************************************************
 
 This code was basically taken from xtmon.c and transformed to use
 the XView toolkit. See the file README.xtmon for the copyright stuff.
 */

/*   This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

 
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/times.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <ctype.h>
#include <signal.h>
#include <memory.h>

/* XView headers */
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/frame.h>
#include <xview/notify.h>
#include <xview/notice.h>
#include <xview/icon.h>
#include <xview/svrimage.h>

/* term headers */
#include "includes.h"
#include "client.h"

/* X bitmap files for icon */
#include "xvtmon.xbm"

#ifndef HZ
#define HZ 60
#endif

#ifndef MAX_VAL
#define MAX_VAL 1800
#endif

#ifndef UPDATE_FREQ
#define UPDATE_FREQ 500
#endif

#define STAT(local, st) \
  if (send_command(s, C_STATS, local, "%d",st)< 0) { \
      fprintf(stderr,"C_STATS command failed. Abort.\n"); \
      exit(1); \
      }

Frame frame;
Panel panel;

Panel_item  IncomingCPS, OutgoingCPS, IncomingText, OutgoingText;
struct itimerval timer;
int height, width;


/* Callback for the Quit button: simply quits the application. */
void Quit()
{
  xv_destroy_safe(frame);
  exit(0);
}

void setup_icon(Frame frame)
{
  Server_image image_ok;
  Icon icon;

  image_ok = (Server_image)xv_create(XV_NULL, SERVER_IMAGE,
  	XV_WIDTH,    xvtmon_width,
  	XV_HEIGHT,   xvtmon_height,
  	SERVER_IMAGE_DEPTH,  1,
  	SERVER_IMAGE_X_BITS, xvtmon_bits,
        NULL);
  icon = (Icon)xv_create(frame, ICON,
  	ICON_IMAGE,       image_ok,
  	ICON_MASK_IMAGE,  image_ok,
  	ICON_LABEL,       "xvtmon", 
  	NULL);
  xv_set(frame, FRAME_ICON, icon, NULL);
}


Notify_value do_monitor(Notify_client client,int which)
{
  int last_in, last_out, d1, d2, i, ihist[33],ohist[33];
  int scale=1024, timer=5;
  int s, done, stim;
  int in, out;
  int cooked_out=0;
  float lcomp,rcomp,dtim;
  struct tms Tbuf;
  struct timeval timeout;
  static int max_in=MAX_VAL, max_out=MAX_VAL;

  char in_str[10], out_str[10];

  timeout.tv_sec = 0;
  timeout.tv_usec = 0; 

  /* set_nonblock(0); */
  priority = 3;

  s = connect_server(term_server);

  STAT ( 1, -5);

  scale = atoi(command_result) / 10 + 10;

  STAT ( 1, -3);
  sscanf ( command_result, "%d %d", &last_in, &last_out );
  stim=times(&Tbuf);
  STAT ( 1, -8);
  cooked_out = atoi(command_result);

  done = 0;
  while ( !done )
    { 
      /* Get the local compression stats. */
      STAT ( 1, -2 );
      sscanf ( command_result, "%d %d", &d1, &d2 );
      if (d1 != 0)
	lcomp = ((float) d1 - d2) / ((float) d1) * 100.0;
      else
	lcomp  = 0;

      /* Get the remote compression stats. */
      STAT ( 0, -2 );
      sscanf ( command_result, "%d %d", &d1, &d2 );
      if (d1!=0)
	rcomp=((float) d1-d2)/((float)d1) * 100.0;
      else rcomp = 0;

      /* Get the number of local clients */
      /* waiting to send. */
      STAT (1, -7);
      STAT (0, -7);
      STAT ( 1, -3);
      sscanf ( command_result, "%d %d", &d1, &d2 );
      
      for (i=1;i<33;i++) {
	ihist[i-1]=ihist[i];
	ohist[i-1]=ohist[i];
      }
      dtim=((float)(times(&Tbuf)-stim) * HZ ) / 10000.0;
      stim=times(&Tbuf);
      
      ihist[32]=(d1-last_in)/dtim;
      ohist[32]=(d2-last_out)/dtim;
      
      in = (int)((d1-last_in)/dtim);
      out = (int)((d2-last_out)/dtim);

      /* If we exceed max. values on panel... */
      if (in>max_in) {
        xv_set(IncomingCPS, PANEL_MAX_VALUE, in, NULL);
        max_in=in;
      }
      if (out>max_out) {
        xv_set(OutgoingCPS, PANEL_MAX_VALUE, out, NULL);
        max_out=out;
      }
      
      xv_set(IncomingCPS, PANEL_VALUE, in, NULL);
      xv_set(OutgoingCPS, PANEL_VALUE, out, NULL);
      
      sprintf(in_str,"%d",in);
      sprintf(out_str,"%d",out);
      
      xv_set(IncomingText, PANEL_LABEL_STRING, in_str, NULL);
      xv_set(OutgoingText, PANEL_LABEL_STRING, out_str, NULL);

      last_in=d1;last_out=d2;
      
      timeout.tv_sec = timer;
      timeout.tv_usec = 0; 
      done = 1;
    }
  
  close(s);
 
 return NOTIFY_DONE; 

}

Xv_opaque my_notify_proc(Panel_item item)
{
 Xv_notice	notice;
 
 notice = xv_create(panel, NOTICE,
 	NOTICE_MESSAGE_STRINGS, 
  		"xvtmon 0.1, Copyright (C) 1995 Alexandre Naaman",
  		"<hoser@step.polymtl.ca>",
  		"-------------------------------------------------",
  		"xvtmon comes with ABSOLUTELY NO WARRANTY. This is",
  		"free software, you are welcome to redistribute it",
  		"under certain conditions; See the GNU General",
  		"Public License for details.",
 		NULL,
	NOTICE_BUTTON_YES,	"Ok",
	NOTICE_NO_BEEPING,	TRUE,
	XV_SHOW,		TRUE,
	NULL);

 xv_destroy_safe(notice);
 return XV_OK;
} 				

Notify_value do_nothing(Notify_client client,int which)
{ return NOTIFY_DONE; }

void start_process(Panel_item item)
{

  if(!strcmp((char *)xv_get(item,PANEL_LABEL_STRING),"Start")) {
    timer.it_value.tv_usec = (UPDATE_FREQ) * 1000;
    timer.it_interval.tv_usec = (UPDATE_FREQ) * 1000;

    notify_set_itimer_func(frame, do_monitor, ITIMER_REAL, &timer, NULL);
    xv_set(item, PANEL_LABEL_STRING, "Stop", NULL);
  } else {
    timer.it_value.tv_usec = 0;
    timer.it_interval.tv_usec = 0;
    
    notify_set_itimer_func(frame, do_nothing, ITIMER_REAL, &timer, NULL);
    xv_set(item, PANEL_LABEL_STRING, "Start", NULL);
    xv_set(OutgoingText,PANEL_LABEL_STRING, "0", NULL);
    xv_set(IncomingText,PANEL_LABEL_STRING, "0", NULL);
    xv_set(OutgoingCPS, PANEL_VALUE,0, NULL);
    xv_set(IncomingCPS, PANEL_VALUE,0, NULL);
  }
}

void window_resize(Frame frame)
{
   /* Just make window take back original size */
   if(height) xv_set(frame,XV_HEIGHT, height);
   if(width)  xv_set(frame,XV_WIDTH, width);
}

/*********************************************************************
 * Function main.
 *********************************************************************/
int main (int argc,char *argv[])
{
 /* Initialize the toolkit */
 xv_init (XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
  
 /* Initialize top level window */
 frame = (Frame)xv_create(XV_NULL, FRAME,
  	FRAME_LABEL,			"xvtmon",
  	FRAME_SHOW_RESIZE_CORNER,	FALSE,
  	WIN_EVENT_PROC,			window_resize,
  	NULL);
  
 /* Create panel where other panel items will be placed */	
 panel = (Panel)xv_create(frame, PANEL, NULL);

/*
 * Create three Buttons: the first is used to exit the application,
 * the second starts the monitoring process and the third shows some
 * useless info :)
 */

 xv_create(panel, PANEL_BUTTON,
 	PANEL_LABEL_STRING,	"Quit",
 	PANEL_NOTIFY_PROC,	Quit,
 	NULL);

 xv_create(panel, PANEL_BUTTON,
 	PANEL_LABEL_STRING,	"Start",
 	PANEL_NOTIFY_PROC,	start_process,
 	NULL);
 
 xv_create(panel, PANEL_BUTTON,
 	PANEL_LABEL_STRING,	"About...",
 	PANEL_NOTIFY_PROC,	my_notify_proc,
 	NULL);
 	
  IncomingCPS = xv_create(panel, PANEL_GAUGE,
  	PANEL_LABEL_STRING,	"IncomingCPS",
  	PANEL_NEXT_ROW,		-1,
  	PANEL_MIN_VALUE,	0,
  	PANEL_MAX_VALUE,	MAX_VAL,
 	PANEL_VALUE,		0,  	
  	PANEL_TICKS,		5, 
  	NULL);
  	
  IncomingText = xv_create(panel, PANEL_MESSAGE,
  	PANEL_LABEL_STRING,	"0",
  	NULL);	
  	
  OutgoingCPS = xv_create(panel, PANEL_GAUGE,
  	PANEL_LABEL_STRING,	"OutgoingCPS",
  	PANEL_NEXT_ROW,		-1,
  	PANEL_MIN_VALUE,	0,
  	PANEL_MAX_VALUE,	MAX_VAL,
  	PANEL_VALUE,		0,
  	PANEL_TICKS,		5,
  	NULL);
  
  OutgoingText = xv_create(panel, PANEL_MESSAGE,
  	PANEL_LABEL_STRING,	"0",
  	NULL);	
  	
  /* Artifically make sure that we have enough space to dislay numbers
   * beside panel gauges
   */
  xv_set(OutgoingText,PANEL_LABEL_STRING, "00000", NULL);
   
  window_fit(panel);
  window_fit(frame);
  
  setup_icon(frame);
  
  /* Set OutgoingText back to it's normal value */
  xv_set(OutgoingText,PANEL_LABEL_STRING, "0", NULL);
  
  height=(int)xv_get(frame,XV_HEIGHT);
  width =(int)xv_get(frame,XV_WIDTH);
  
  xv_main_loop(frame);
  return 0;   
}